import { Result } from "./result";
export declare const some: <T>(value: T) => Option<T>;
export declare const none: <T>() => Option<T>;
export interface Option<T> {
    isSome(): boolean;
    isNone(): boolean;
    expect(error: any): T;
    unwrap(): T;
    unwrapOr(value: T): T;
    unwrapOrElse(fn: () => T): T;
    map<U>(fn: (value: T) => U): Option<U>;
    mapOr<U>(value: U, fn: (value: T) => U): U;
    mapOrElse<U>(fnMap: (value: T) => U, fnOrElse: () => U): U;
    okOr<E>(error: E): Result<T, E>;
    okOrElse<E>(fn: () => E): Result<T, E>;
    and<U>(optb: Option<U>): Option<U>;
    andThen<U>(fn: (value: T) => Option<U>): Option<U>;
    filter(fn: (value: T) => boolean): Option<T>;
    or(optb: Option<T>): Option<T>;
    orElse(fn: () => Option<T>): Option<T>;
    xor(optb: Option<T>): Option<T>;
}
export declare class Some<T> implements Option<T> {
    private readonly value;
    constructor(value: T);
    isSome(): boolean;
    isNone(): boolean;
    expect(_error: any): T;
    unwrap(): T;
    unwrapOr(_value: T): T;
    unwrapOrElse(_fn: () => T): T;
    map<U>(fn: (value: T) => U): Option<U>;
    mapOr<U>(_value: U, fn: (value: T) => U): U;
    mapOrElse<U>(fnMap: (value: T) => U, _fnOrElse: () => U): U;
    okOr<E>(_error: E): Result<T, E>;
    okOrElse<E>(_fn: () => E): Result<T, E>;
    and<U>(optb: Option<U>): Option<U>;
    andThen<U>(fn: (value: T) => Option<U>): Option<U>;
    filter(fn: (value: T) => boolean): Option<T>;
    or(_optb: Option<T>): Option<T>;
    orElse(_fn: () => Option<T>): Option<T>;
    xor(optb: Option<T>): Option<T>;
}
export declare class None<T> implements Option<T> {
    isSome(): boolean;
    isNone(): boolean;
    expect(error: any): T;
    unwrap(): T;
    unwrapOr(value: T): T;
    unwrapOrElse(fn: () => T): T;
    map<U>(_fn: (value: T) => U): Option<U>;
    mapOr<U>(value: U, _fn: (value: T) => U): U;
    mapOrElse<U>(_fnMap: (value: T) => U, fnOrElse: () => U): U;
    okOr<E>(error: E): Result<T, E>;
    okOrElse<E>(fn: () => E): Result<T, E>;
    and<U>(_optb: Option<U>): Option<U>;
    andThen<U>(_fn: (value: T) => Option<U>): Option<U>;
    filter(_fn: (value: T) => boolean): Option<T>;
    or(optb: Option<T>): Option<T>;
    orElse(fn: () => Option<T>): Option<T>;
    xor(optb: Option<T>): Option<T>;
}
//# sourceMappingURL=option.d.ts.map