"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const result_1 = require("./result");
exports.some = (value) => new Some(value);
exports.none = () => new None();
class Some {
    constructor(value) {
        this.value = value;
    }
    isSome() {
        return true;
    }
    isNone() {
        return false;
    }
    expect(_error) {
        return this.value;
    }
    unwrap() {
        return this.value;
    }
    unwrapOr(_value) {
        return this.value;
    }
    unwrapOrElse(_fn) {
        return this.value;
    }
    map(fn) {
        return new Some(fn(this.value));
    }
    mapOr(_value, fn) {
        return fn(this.value);
    }
    mapOrElse(fnMap, _fnOrElse) {
        return fnMap(this.value);
    }
    okOr(_error) {
        return result_1.ok(this.value);
    }
    okOrElse(_fn) {
        return result_1.ok(this.value);
    }
    and(optb) {
        return optb;
    }
    andThen(fn) {
        return fn(this.value);
    }
    filter(fn) {
        // @ts-ignore
        return fn(this.value) ? new Some(this.value) : new None();
    }
    or(_optb) {
        return new Some(this.value);
    }
    orElse(_fn) {
        return new Some(this.value);
    }
    xor(optb) {
        return optb.isNone() ? this : new None();
    }
}
exports.Some = Some;
class None {
    isSome() {
        return false;
    }
    isNone() {
        return true;
    }
    expect(error) {
        throw error;
    }
    unwrap() {
        throw Error();
    }
    unwrapOr(value) {
        return value;
    }
    unwrapOrElse(fn) {
        return fn();
    }
    map(_fn) {
        return new None();
    }
    mapOr(value, _fn) {
        return value;
    }
    mapOrElse(_fnMap, fnOrElse) {
        return fnOrElse();
    }
    okOr(error) {
        return result_1.err(error);
    }
    okOrElse(fn) {
        return result_1.err(fn());
    }
    and(_optb) {
        return new None();
    }
    andThen(_fn) {
        return new None();
    }
    filter(_fn) {
        return new None();
    }
    or(optb) {
        return optb;
    }
    orElse(fn) {
        return fn();
    }
    xor(optb) {
        return optb.isSome() ? optb : new None();
    }
}
exports.None = None;
//# sourceMappingURL=option.js.map