"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const option_1 = require("./option");
exports.emptyOk = () => new Ok(undefined);
exports.emptyErr = () => new Err(undefined);
exports.ok = (value) => new Ok(value);
exports.err = (error) => new Err(error);
class Ok {
    constructor(value) {
        this.value = value;
    }
    isErr() {
        return false;
    }
    isOk() {
        return true;
    }
    ok() {
        return option_1.some(this.value);
    }
    err() {
        return option_1.none();
    }
    unwrap() {
        return this.value;
    }
    unwrapErr() {
        throw this.value;
    }
    expectErr(error) {
        throw error;
    }
    expect(_error) {
        return this.value;
    }
    unwrapOr(_value) {
        return this.value;
    }
    unwrapOrElse(_fn) {
        return this.value;
    }
    or(_res) {
        return exports.ok(this.value);
    }
    orElse(_fn) {
        return exports.ok(this.value);
    }
    and(res) {
        return res;
    }
    andThen(fn) {
        return fn(this.value);
    }
    map(fn) {
        return exports.ok(fn(this.value));
    }
    mapErr(_fn) {
        return exports.ok(this.value);
    }
    mapOrElse(fnMap, fnOrElse) {
        return this.map(fnMap).unwrapOrElse(fnOrElse);
    }
}
exports.Ok = Ok;
class Err {
    constructor(error) {
        this.error = error;
    }
    isErr() {
        return true;
    }
    isOk() {
        return false;
    }
    ok() {
        return option_1.none();
    }
    err() {
        return option_1.some(this.error);
    }
    unwrap() {
        throw this.error;
    }
    unwrapErr() {
        return this.error;
    }
    expect(error) {
        throw error;
    }
    expectErr(_error) {
        return this.error;
    }
    unwrapOr(value) {
        return value;
    }
    unwrapOrElse(fn) {
        return fn(this.error);
    }
    or(res) {
        return res;
    }
    orElse(fn) {
        return fn(this.error);
    }
    and(_res) {
        return exports.err(this.error);
    }
    andThen(_fn) {
        return exports.err(this.error);
    }
    map(_fn) {
        return exports.err(this.error);
    }
    mapErr(fn) {
        return exports.err(fn(this.error));
    }
    mapOrElse(fnMap, fnOrElse) {
        return this.map(fnMap).unwrapOrElse(fnOrElse);
    }
}
exports.Err = Err;
//# sourceMappingURL=result.js.map